----- GLOBAL VARIABLES -----
takeSpeedMeasurement = false
determineSpeedDirection = false

inReportingPhase = false
inAmplifyPhase = false
lastUpdateAt = 0
lastUpdateZCoord = 0.0

LinkPointer = 0
LinkXAddress = 0
LinkZAddress = 0
currentFrame = 0

zAxisChecked = false
xAxisChecked = false
skipAxisCheck = false

directionIncreasing = false
waitForSpeedReverse = false
waitForNextReverse = false

lastXCoord = 0.0
lastZCoord = 0.0

lowBound = 0.0
highBound = 0.0

lowBoundDone = false
highBoundDone = false

speedPerSec = 0.0

speedPerSecX = 0.0
speedPerSecZ = 0.0

counter = 0
counterNotMoving = 0

lastSpeed = 0.0
measurementsDone = 0

turnDelay = 0
initialMessage = false



--USER VARIABLES
reportDistance = false
targetZ = -3426.0 --Poe Skip

amplifySlide = true
amplifyFactor = 10000


function onScriptStart()

	takeSpeedMeasurement = true
	determineSpeedDirection = true

	LinkPointer = GetPointerNormal(0x3dce54)
	LinkZAddress = LinkPointer + 0x8

	lastZCoord = ReadValueFloat(LinkZAddress)
	currentFrame = GetFrameCount()

	turnDelay = 30

	MsgBox("Script Started")
end

function onScriptCancel()

	MsgBox("Script Cancelled")

end

function onScriptUpdate()

	local frames = GetFrameCount()
	local eventFlag = ReadValue8(0x40b16d)
	local animationID = ReadValue8(0x4513F7)

	LinkPointer = GetPointerNormal(0x3dce54)
	LinkXAddress = LinkPointer + 0x0
	LinkZAddress = LinkPointer + 0x8

	local xCoord = ReadValueFloat(LinkXAddress)
	local zCoord = ReadValueFloat(LinkZAddress)
	local currCoord = 0.0
	local lastCoord = 0.0
	
	if (frames ~= currentFrame) then

		currentFrame = GetFrameCount()

		if (eventFlag == 1 and animationID == 191) then

		if (initialMessage == false) then

			MsgBox("Possible Slide Detected...", 3000)
			initialMessage = true
		end

		if (turnDelay > 0) then
			turnDelay = turnDelay - 1
		end

		if (turnDelay == 0) then

		if (inReportingPhase == true and lastUpdateAt + 300 < frames) then

			lastUpdateAt = frames

			local distanceToTarget = targetZ - zCoord

			MsgBox(string.format("Distance to Target: %f", distanceToTarget), 10000)
			
			local eta = distanceToTarget / speedPerSecZ
			eta = eta / 60 --minutes
			eta = eta / 60 --hours

			eta = round(eta, 2)

			MsgBox(string.format("ETA (in hours): %.2f", eta), 10000)

			lastUpdateZCoord = zCoord
		end

		if (inAmplifyPhase == true) then
			
			--X
			local speedPerFrameX = speedPerSecX / 30
			local addToPosX = speedPerFrameX * amplifyFactor

			newXPos = xCoord + addToPosX

			WriteValueFloat(LinkXAddress, newXPos)

			--Z
			local speedPerFrameZ = speedPerSecZ / 30
			local addToPosZ = speedPerFrameZ * amplifyFactor

			newZPos = zCoord + addToPosZ

			WriteValueFloat(LinkZAddress, newZPos)
		end

		if (takeSpeedMeasurement == true) then

			if (xAxisChecked == false) then
				currCoord = xCoord
				lastCoord = lastXCoord
			elseif (zAxisChecked == false) then
				currCoord = zCoord
				lastCoord = lastZCoord
			end

			if (lowBoundDone == true and highBoundDone == true) then
				waitForSpeedReverse = false
				waitForNextReverse = true
			end

			
			if (waitForNextReverse == true or skipAxisCheck == true) then

				if (skipAxisCheck == false and directionIncreasing == true and currCoord <= lastCoord) then

					speedPerSec = lastCoord - lowBound

					if (measurementsDone == 0) then

						lastSpeed = speedPerSec
						measurementsDone = measurementsDone + 1

					else
						if (lastSpeed == speedPerSec) then

							measurementsDone = measurementsDone + 1
						else
							measurementsDone = 0
						end
				
					end

					MsgBox("Checking for Speed", 2000)

					waitForNextReverse = false
					determineSpeedDirection = true
					highBoundDone = false
					lowBoundDone = false
					counter = 0
					counterNotMoving = 0

				elseif (skipAxisCheck == false and directionIncreasing == false and currCoord >= lastCoord) then

					speedPerSec = lastCoord - highBound

					MsgBox("Checking for Speed", 1500)

					if (measurementsDone == 0) then

						lastSpeed = speedPerSec
						measurementsDone = measurementsDone + 1

					else
						if (lastSpeed == speedPerSec) then

							measurementsDone = measurementsDone + 1
						else
							measurementsDone = 0
						end
				
					end

					waitForNextReverse = false
					determineSpeedDirection = true
					highBoundDone = false
					lowBoundDone = false
					counter = 0
					counterNotMoving = 0
				end

				if (measurementsDone == 2 or skipAxisCheck == true) then

					if (xAxisChecked == false) then

						xAxisChecked = true
						speedPerSecX = speedPerSec
						
						waitForNextReverse = false
						determineSpeedDirection = true
						highBoundDone = false
						lowBoundDone = false
						counter = 0
						counterNotMoving = 0
						measurementsDone = 0
						takeSpeedMeasurement = true
						skipAxisCheck = false

						currCoord = zCoord
						lastCoord = lastZCoord

					elseif (zAxisChecked == false) then

						zAxisChecked = true
						speedPerSecZ = speedPerSec

						takeSpeedMeasurement = false
						determineSpeedDirection = false
						skipAxisCheck = false

						if (reportDistance == true) then

							inReportingPhase = true
							lastUpdateAt = frames + 120
							lastUpdateZCoord = zCoord
						end

						if (amplifySlide == true) then

							inAmplifyPhase = true
						end

						if (speedPerSecX > 0) then
							MsgBox("X Coords are increasing!", 15000)
						elseif (speedPerSecX < 0) then
							MsgBox("X Coords are decreasing!", 15000)
						else
							MsgBox("X Coords are not moving!", 15000)
						end

						if (speedPerSecX ~= 0) then

							MsgBox(string.format("Speed on X Axis (Voxels per Second): %f", speedPerSecX), 15000)
						end


						if (speedPerSecZ > 0) then
							MsgBox("Z Coords are increasing!", 15000)
						elseif (speedPerSecZ < 0) then
							MsgBox("Z Coords are decreasing!", 15000)
						else
							MsgBox("Z Coords are not moving!", 15000)
						end

						if (speedPerSecZ ~= 0) then

							MsgBox(string.format("Speed on Z Axis (Voxels per Second): %f", speedPerSecZ), 15000)
						end
					end
						
				end

			end

				
			if (waitForSpeedReverse == true) then

				if (directionIncreasing == true and currCoord <= lastCoord) then

					--MsgBox("reversed")
					lowBound = lastCoord
					directionIncreasing = false
					
					lowBoundDone = true

				elseif (directionIncreasing == false and currCoord >= lastCoord) then
					
					--MsgBox("reversed")
					highBound = lastCoord
					directionIncreasing = true
					
					highBoundDone = true
				end

			end

			if (determineSpeedDirection == true) then

				if (currCoord == lastCoord) then

					counter = 0
					counterNotMoving = counterNotMoving + 1

					if (counterNotMoving == 30) then

						if (xAxisChecked == false) then

							--MsgBox("No slide on X Axis!", 10000)
	
						elseif (zAxisChecked == false) then
							
							--MsgBox("No slide on Z Axis!", 10000)
						end
			
						determineSpeedDirection = false
						speedPerSec = 0.0
						skipAxisCheck = true
						counterNotMoving = 0
					end

				elseif (currCoord > lastCoord) then

					counter = counter + 1
					counterNotMoving = 0

					if (counter == 2) then
						
						--MsgBox("decreasing atm")
						directionIncreasing = true
						determineSpeedDirection = false

						waitForSpeedReverse = true
					end

				elseif (currCoord < lastCoord) then
					
					counter = counter + 1
					counterNotMoving = 0

					if (counter == 2) then
						
						--MsgBox("increasing atm")
						directionIncreasing = false
						determineSpeedDirection = false

						waitForSpeedReverse = true
					end
				end

			end
			
		end
	
	end

	else
		inReportingPhase = false
		inAmplifyPhase = false

		waitForNextReverse = false
		determineSpeedDirection = true
		highBoundDone = false
		lowBoundDone = false
		counter = 0
		counterNotMoving = 0
		measurementsDone = 0
		takeSpeedMeasurement = true

		zAxisChecked = false
		xAxisChecked = false
		skipAxisCheck = false
		
		turnDelay = 30
		initialMessage = false
	end
	
	lastXCoord = xCoord
	lastZCoord = zCoord
	end
end

function round(num, idp)

  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult

end

function onStateLoaded()
	
end

function onStateSaved()
	
end